// New Plugin
// Initial code generated by Softimage SDK Wizard
// Executed Wed Feb 1 00:51:44 UTC+0200 2012 by Core
// 
// Tip: To add a command to this plug-in, right-click in the 
// script editor and choose Tools > Add Command.

function XSILoadPlugin( in_reg )
{
	in_reg.Author = "Oleg Bliznuk";
	in_reg.Name = "EFXMenu";
	in_reg.Email = "gbotfx@gmail.com";
	//in_reg.URL = //"http://www.exocortex.com/plugins/implosiafx";
	in_reg.Major = 1;
	in_reg.Minor = 1; 

    // Register a single Menu entry point on the Help menu
	in_reg.RegisterMenu( siMenuMainTopLevelID   , "EFX" );
	//RegistrationInsertionPoint - do not remove this line

	return true;
};

function XSIUnloadPlugin( in_reg )
{
	var strPluginName;
	strPluginName = in_reg.Name;
	Application.LogMessage(strPluginName + " has been unloaded.",siVerbose);
	return true;
};

////////////
function EFX_Init( in_context )
{

        // Get the menu object from the Context input
        var topMenu = in_context.Source;

        var CREATION_LABEL = topMenu.AddItem( "Create", siMenuItemSection  );
        CREATION_LABEL.SetBackgroundColor (255, 190, 0 );

		//topMenu.AddCallbackItem( "Create Static Volume", "efx_createStaticVolume" );
		//topMenu.AddSeparatorItem();
		topMenu.AddCallbackItem( "Create Smoke", "efx_createSmoke" );
		topMenu.AddCallbackItem( "Create Fire", "efx_createFire" );
		topMenu.AddCallbackItem( "Create Smoke And Fire", "efx_createSmokeAndFire" );
		

		
		// prev win and shit like that
		  var UTIL_LABEL = topMenu.AddItem( "Utils", siMenuItemSection  );
		 UTIL_LABEL.SetBackgroundColor (255, 190, 0 );
		 topMenu.AddCallbackItem( "Open Preview Window", "efx_openprevwin" );
		 
		 //licensing
        var LIC_LABEL = topMenu.AddItem( "Licensing", siMenuItemSection  );
		 LIC_LABEL.SetBackgroundColor (255, 190, 0 );
		 topMenu.AddCallbackItem( "Install node-locked", "efx_licnodelock" );
		 topMenu.AddCallbackItem( "Install floating", "efx_licfloat" );
		 topMenu.AddCallbackItem( "Deinstall", "efx_licremove" );
		 topMenu.AddSeparatorItem();
		 topMenu.AddCallbackItem( "View status", "efx_getNetworkInfo" );
		 topMenu.AddSeparatorItem();
		 topMenu.AddCallbackItem( "Legal Notice", "efx_EULA" );
	return true;
};


// =============================================
function efx_licnodelock ( in_ctxt)
{
	gui_licnl_Main ();
	return true;
}

function efx_licfloat( in_ctxt)
{
	gui_licfl_Main();
	return true;
}
//set unlicensed status
function efx_licremove ( in_ctxt)
{
	EFX_DeinstallLicense();
	return true;
}

function efx_getNetworkInfo( in_ctxt )
{
	gui_getinfo_Main ();
	return true;
}










//////////////////////////////////////////////////////////////
// =============================================
//
// @@ smoke 
//
// =============================================
function efx_createSmoke( in_ctxt )
{
var meshCubeCont = CreatePrim("Cube", "MeshSurface", null, null);
SetValue(meshCubeCont+".Name", "EFX_SmokeActiveContainer", null);
SetValue(meshCubeCont+".visibility.selectability", false, null);

// select  arni or mray
if (  GetValue ("Passes.RenderOptions.Renderer" )  == "Arnold Render" )
	{
			// apply arnold shader
		var factoryBase = Application.InstallationPath(siFactoryPath); 
      var path = XSIUtils.BuildPath(factoryBase, "Data", "DSPresets", "Shaders", "Material", "Constant.Preset");
      ApplyShader(path, "", null, "", siLetLocalMaterialsOverlap);
   
         var xsiObj = meshCubeCont;
         shader = xsiObj.material.surface.source.parent;
         if (shader != null)
         {
            DeleteObj(shader);      
            shader = CreateShaderFromProgID("XSIRTCOMPOUND.EFX_FluidShaderGraph_ai.1.0", xsiObj.material, null);
            SIConnectShaderToCnxPoint(shader, xsiObj.material + ".volume", false);
			SetValue(xsiObj.material +".Name", "EFX_FluidSmokeShader", null);
			SetExpr(shader+".CurrentFrame", "Fc", null);
			SetValue(shader+".FolderPath", ActiveProject2.Path+"/efx_cache/" + ActiveProject.ActiveScene, null);
         }
	}
else
 {


 // apply mentalray then
		var factoryBase = Application.InstallationPath(siFactoryPath); 
      var path = XSIUtils.BuildPath(factoryBase, "Data", "DSPresets", "Shaders", "Material", "Constant.Preset");
      ApplyShader(path, "", null, "", siLetLocalMaterialsOverlap);
   
         var xsiObj = meshCubeCont;
         shader = xsiObj.material.surface.source.parent;
         if (shader != null)
         {
            DeleteObj(shader);      
            shader = CreateShaderFromProgID("XSIRTCOMPOUND.EFX_FluidShaderGraph_mi.1.0", xsiObj.material, null);
            SIConnectShaderToCnxPoint(shader, xsiObj.material + ".volume", false);
			SetValue(xsiObj.material +".Name", "EFX_FluidSmokeShader", null);
			SetExpr(shader+".CurrentFrame", "Fc", null);
			SetValue(shader+".FolderPath", ActiveProject2.Path+"/efx_cache/" + ActiveProject.ActiveScene, null);
         }
 }


var simTree = CreateSimulatedICETree(meshCubeCont, siNode, null);
SetValue(simTree+".Name", "EFX_Simulate", null);

var initTree = ApplyOp("ICETree", meshCubeCont, siNode, null, null, 0);
SetValue(initTree+".Name", "EFX_Initialize", null);
MoveOperatorAfter(meshCubeCont + ".polymsh", initTree , meshCubeCont + ".polymsh.geom");

var postTree = ApplyOp("ICETree", meshCubeCont, siNode, null, null, 0);
SetValue(postTree+".Name", "EFX_DataIO", null);
MoveOperatorAfter(meshCubeCont + ".polymsh", postTree , meshCubeCont + ".polymsh.simulationmarker");

//  =========================== setup initialization  =========================== 
comp_initfluid = AddICECompoundNode("EFX Set System Parameters",initTree);
ConnectICENodes(initTree + ".port1", comp_initfluid+".Perform");

SetValue(comp_initfluid+".Solve_Heat", false, null);
SetValue(comp_initfluid+".Solve_Fuel", false, null);

// =========================== setup simulation  =========================== 
// add execute node
var execNodesHub = AddICENode("$XSI_DSPRESETS\\ICENodes\\ExecuteNode.Preset", simTree);
ConnectICENodes(simTree+".port1", execNodesHub+".execute");


// add more execution ports
for ( i = 0 ; i<10; ++i )
	AddPortToICENode(execNodesHub + ".port1", siNodePortDataInsertionLocationAfter);

var execHubComment = CreateICENodeComment(execNodesHub);
SetValue(execHubComment+".Text", "disconnect after simulation and caching", null);

// add base simulation parameters
comp_setBaseFluidParams = AddICECompoundNode("EFX Set Fluid Simulation Parameters", simTree);
ConnectICENodes(execNodesHub+".port2", comp_setBaseFluidParams+ ".Perform");
SetValue(comp_setBaseFluidParams+".Smoke_Buoyancy", -1, null);

// add sdf emitter
comp_sdfEmit = AddICECompoundNode("EFX Emit From SDF", simTree);
ConnectICENodes(execNodesHub + ".port3", comp_sdfEmit+".Perform");

SetValue(comp_sdfEmit+".Emit_Heat", false, null);
SetValue(comp_sdfEmit+".Emit_Fuel", false, null);
SetValue(comp_sdfEmit+".Emit_Smoke", true, null);
SetValue(comp_sdfEmit+".Emit_Smoke", true, null);
SetValue(comp_sdfEmit+".Direct_Velocity_y", 10, null);


// add sdf from prim
comp_prim2sdf = AddICECompoundNode("EFX SDF From Primitive", simTree);
ConnectICENodes(comp_sdfEmit + ".Emitter_SDF", comp_prim2sdf+".SDF");

// add emitter manipulator
var emitterManip= GetPrim("Null", null, null, null); 
SetValue(emitterManip+".Name", "EFX_SmokeEmitter", null);
//SetValue("EFX_Emitter.null.shadow_icon", 10, null);
SetValue(emitterManip+".kine.global.sclx", 5, null);
SetValue(emitterManip+".kine.global.scly", 5, null);
SetValue(emitterManip+".kine.global.sclz", 5, null);

// connect it
var nd_getEmitNullData = AddICENode("GetDataNode",simTree);
SetValue ( nd_getEmitNullData + ".reference", emitterManip.name, null);
ConnectICENodes(comp_prim2sdf+".Manipulator_Ref", nd_getEmitNullData+".outname");



// add sim node
comp_simMainNode= AddICECompoundNode("EFX Simulate Fluid", simTree);
ConnectICENodes(execNodesHub+".port11", comp_simMainNode+ ".Perform");


// add max container manipulator
var maxCont = GetPrim("Null", null, null, null);
SetValue(maxCont+".Name", "EFX_SmokeBoundingContainer", null);
SetValue(maxCont+".null.primary_icon", 4, null);
SetValue(maxCont+".kine.global.sclx", 50, null);
SetValue(maxCont+".kine.global.scly", 50, null);
SetValue(maxCont+".kine.global.sclz", 50, null);
SetValue(maxCont+".kine.global.posy", 15, null);

// connect it
var nd_getMaxcontNullData = AddICENode("GetDataNode",simTree);
SetValue ( nd_getMaxcontNullData + ".reference", maxCont.name, null);
ConnectICENodes(comp_setBaseFluidParams+".Bounding_Container", nd_getMaxcontNullData+".outname");


// =========================== setup IO and display  =========================== 
for ( i = 0 ; i<10; ++i )
	AddPortToICENode(postTree + ".port1", siNodePortDataInsertionLocationAfter);

var comp_udpContFields = AddICECompoundNode("EFX Update Active Container Cube", postTree);
ConnectICENodes(postTree+".port1", comp_udpContFields+".Perform");

var comp_gigaShader = AddICECompoundNode("EFX Fluid Smoke Shader", postTree);
ConnectICENodes(postTree+".port2", comp_gigaShader+".Perform");

var comp_volRender= AddICECompoundNode("EFX Volume Render", postTree);
ConnectICENodes(postTree+".port3", comp_volRender+".Perform");

var comp_dispSS = AddICECompoundNode("EFX Display Scalar Slice", postTree);
ConnectICENodes(postTree+".port9", comp_dispSS+".Perform");

var comp_dispNativeVx = AddICECompoundNode("EFX Native Display Voxels", postTree);
ConnectICENodes(postTree+".port10", comp_dispNativeVx+".Perform");


	
// attach arnold properties and set proper raymarch stepsize when arni installed
if (Application.Plugins ( "Arnold Render" ) )
	{
		SITOA_AddParametersProperties(meshCubeCont, null);
		SetValue( meshCubeCont+".Arnold_Parameters.step_size", 0.5, null);		
	}


// open preview window
efx_openprevwin ();

//========================= finalize ===============================
// select
SelectObj(meshCubeCont, null, null);


    return true;
};


// =============================================
//
// @@ fire 
//
// =============================================
function efx_createFire( in_ctxt )
{
var meshCubeCont = CreatePrim("Cube", "MeshSurface", null, null);
SetValue(meshCubeCont+".Name", "EFX_FireActiveContainer", null);
SetValue(meshCubeCont+".visibility.selectability", false, null);


// select  arni or mray
if (  GetValue ("Passes.RenderOptions.Renderer" )  == "Arnold Render" )
	{
			// apply arnold shader
		var factoryBase = Application.InstallationPath(siFactoryPath); 
      var path = XSIUtils.BuildPath(factoryBase, "Data", "DSPresets", "Shaders", "Material", "Constant.Preset");
      ApplyShader(path, "", null, "", siLetLocalMaterialsOverlap);
   
         var xsiObj = meshCubeCont;
         shader = xsiObj.material.surface.source.parent;
         if (shader != null)
         {
            DeleteObj(shader);      
            shader = CreateShaderFromProgID("XSIRTCOMPOUND.EFX_FluidShaderGraph_ai.1.0", xsiObj.material, null);
            SIConnectShaderToCnxPoint(shader, xsiObj.material + ".volume", false);
			SetValue(xsiObj.material +".Name", "EFX_FluidFireShader", null);
			SetExpr(shader+".CurrentFrame", "Fc", null);
			SetValue(shader+".FolderPath", ActiveProject2.Path+"/efx_cache/" + ActiveProject.ActiveScene, null);
         }
	}
else
 {

 // apply mentalray then
		var factoryBase = Application.InstallationPath(siFactoryPath); 
      var path = XSIUtils.BuildPath(factoryBase, "Data", "DSPresets", "Shaders", "Material", "Constant.Preset");
      ApplyShader(path, "", null, "", siLetLocalMaterialsOverlap);
   
         var xsiObj = meshCubeCont;
         shader = xsiObj.material.surface.source.parent;
         if (shader != null)
         {
            DeleteObj(shader);      
            shader = CreateShaderFromProgID("XSIRTCOMPOUND.EFX_FluidShaderGraph_mi.1.0", xsiObj.material, null);
            SIConnectShaderToCnxPoint(shader, xsiObj.material + ".volume", false);
			SetValue(xsiObj.material +".Name", "EFX_FluidFireShader", null);
			SetExpr(shader+".CurrentFrame", "Fc", null);
			SetValue(shader+".FolderPath", ActiveProject2.Path+"/efx_cache/" + ActiveProject.ActiveScene, null);
         }
 }


var simTree = CreateSimulatedICETree(meshCubeCont, siNode, null);
SetValue(simTree+".Name", "EFX_Simulate", null);

var initTree = ApplyOp("ICETree", meshCubeCont, siNode, null, null, 0);
SetValue(initTree+".Name", "EFX_Initialize", null);
MoveOperatorAfter(meshCubeCont + ".polymsh", initTree , meshCubeCont + ".polymsh.geom");

var postTree = ApplyOp("ICETree", meshCubeCont, siNode, null, null, 0);
SetValue(postTree+".Name", "EFX_DataIO", null);
MoveOperatorAfter(meshCubeCont + ".polymsh", postTree , meshCubeCont + ".polymsh.simulationmarker");

//  =========================== setup initialization  =========================== 
comp_initfluid = AddICECompoundNode("EFX Set System Parameters",initTree);
ConnectICENodes(initTree + ".port1", comp_initfluid+".Perform");

SetValue(comp_initfluid+".Solve_Smoke", false, null);

// =========================== setup simulation  =========================== 
// add execute node
var execNodesHub = AddICENode("$XSI_DSPRESETS\\ICENodes\\ExecuteNode.Preset", simTree);
ConnectICENodes(simTree+".port1", execNodesHub+".execute");


// add more execution ports
for ( i = 0 ; i<10; ++i )
	AddPortToICENode(execNodesHub + ".port1", siNodePortDataInsertionLocationAfter);

var execHubComment = CreateICENodeComment(execNodesHub);
SetValue(execHubComment+".Text", "disconnect after simulation and caching", null);

// add base simulation parameters
comp_setBaseFluidParams = AddICECompoundNode("EFX Set Fluid Simulation Parameters", simTree);
ConnectICENodes(execNodesHub+".port2", comp_setBaseFluidParams+ ".Perform");

// add sdf emitter
comp_sdfEmit = AddICECompoundNode("EFX Emit From SDF", simTree);
ConnectICENodes(execNodesHub + ".port3", comp_sdfEmit+".Perform");

// add sdf from prim
comp_prim2sdf = AddICECompoundNode("EFX SDF From Primitive", simTree);
ConnectICENodes(comp_sdfEmit + ".Emitter_SDF", comp_prim2sdf+".SDF");

// add emitter manipulator
var emitterManip= GetPrim("Null", null, null, null); 
SetValue(emitterManip+".Name", "EFX_FireEmitter", null);
//SetValue("EFX_Emitter.null.shadow_icon", 10, null);
SetValue(emitterManip+".kine.global.sclx", 5, null);
SetValue(emitterManip+".kine.global.scly", 5, null);
SetValue(emitterManip+".kine.global.sclz", 5, null);

// connect it
var nd_getEmitNullData = AddICENode("GetDataNode",simTree);
SetValue ( nd_getEmitNullData + ".reference", emitterManip.name, null);
ConnectICENodes(comp_prim2sdf+".Manipulator_Ref", nd_getEmitNullData+".outname");

// add trubulence
comp_turbcur = AddICECompoundNode("EFX Add Turbulence", simTree);
ConnectICENodes(execNodesHub+".port10", comp_turbcur+ ".Perform");


// add sim node
comp_simMainNode= AddICECompoundNode("EFX Simulate Fluid", simTree);
ConnectICENodes(execNodesHub+".port11", comp_simMainNode+ ".Perform");


// add max container manipulator
var maxCont = GetPrim("Null", null, null, null);
SetValue(maxCont+".Name", "EFX_FireBoundingContainer", null);
SetValue(maxCont+".null.primary_icon", 4, null);
SetValue(maxCont+".kine.global.sclx", 50, null);
SetValue(maxCont+".kine.global.scly", 50, null);
SetValue(maxCont+".kine.global.sclz", 50, null);
SetValue(maxCont+".kine.global.posy", 15, null);

// connect it
var nd_getMaxcontNullData = AddICENode("GetDataNode",simTree);
SetValue ( nd_getMaxcontNullData + ".reference", maxCont.name, null);
ConnectICENodes(comp_setBaseFluidParams+".Bounding_Container", nd_getMaxcontNullData+".outname");


// =========================== setup IO and display  =========================== 
for ( i = 0 ; i<10; ++i )
	AddPortToICENode(postTree + ".port1", siNodePortDataInsertionLocationAfter);

var comp_udpContFields = AddICECompoundNode("EFX Update Active Container Cube", postTree);
ConnectICENodes(postTree+".port1", comp_udpContFields+".Perform");

var comp_gigaShader = AddICECompoundNode("EFX Fluid Fire Shader", postTree);
ConnectICENodes(postTree+".port2", comp_gigaShader+".Perform");

var comp_volRender= AddICECompoundNode("EFX Volume Render", postTree);
ConnectICENodes(postTree+".port3", comp_volRender+".Perform");

var comp_dispSS = AddICECompoundNode("EFX Display Scalar Slice", postTree);
ConnectICENodes(postTree+".port9", comp_dispSS+".Perform");
SetValue(comp_dispSS+".Source", 2, null);


var comp_dispNativeVx = AddICECompoundNode("EFX Native Display Voxels", postTree);
ConnectICENodes(postTree+".port10", comp_dispNativeVx+".Perform");


	
// attach arnold properties and set proper raymarch stepsize when arni installed
if (Application.Plugins ( "Arnold Render" ) )
	{
		SITOA_AddParametersProperties(meshCubeCont, null);
		SetValue( meshCubeCont+".Arnold_Parameters.step_size", 0.5, null);
	}


// open preview window
efx_openprevwin ();

//========================= finalize ===============================
// select
SelectObj(meshCubeCont, null, null);


    return true;
};



// =============================================
//
// @@ smoke and fire 
//
// =============================================
function efx_createSmokeAndFire( in_ctxt )
{
var meshCubeCont = CreatePrim("Cube", "MeshSurface", null, null);
SetValue(meshCubeCont+".Name", "EFX_FireSmokeActiveContainer", null);
SetValue(meshCubeCont+".visibility.selectability", false, null);


// select  arni or mray
if (  GetValue ("Passes.RenderOptions.Renderer" )  == "Arnold Render" )
	{
			// apply arnold shader
		var factoryBase = Application.InstallationPath(siFactoryPath); 
      var path = XSIUtils.BuildPath(factoryBase, "Data", "DSPresets", "Shaders", "Material", "Constant.Preset");
      ApplyShader(path, "", null, "", siLetLocalMaterialsOverlap);
   
         var xsiObj = meshCubeCont;
         shader = xsiObj.material.surface.source.parent;
         if (shader != null)
         {
            DeleteObj(shader);      
            shader = CreateShaderFromProgID("XSIRTCOMPOUND.EFX_FluidShaderGraph_ai.1.0", xsiObj.material, null);
            SIConnectShaderToCnxPoint(shader, xsiObj.material + ".volume", false);
			SetValue(xsiObj.material +".Name", "EFX_FluidFireSmokeShader", null);
			SetExpr(shader+".CurrentFrame", "Fc", null);
			SetValue(shader+".FolderPath",  ActiveProject2.Path+"/efx_cache/" + ActiveProject.ActiveScene, null);
         }
	}

else
 {

 // apply mentalray then
 		var factoryBase = Application.InstallationPath(siFactoryPath); 
      var path = XSIUtils.BuildPath(factoryBase, "Data", "DSPresets", "Shaders", "Material", "Constant.Preset");
      ApplyShader(path, "", null, "", siLetLocalMaterialsOverlap);
   
         var xsiObj = meshCubeCont;
         shader = xsiObj.material.surface.source.parent;
         if (shader != null)
         {
            DeleteObj(shader);      
            shader = CreateShaderFromProgID("XSIRTCOMPOUND.EFX_FluidShaderGraph_mi.1.0", xsiObj.material, null);
            SIConnectShaderToCnxPoint(shader, xsiObj.material + ".volume", false);
			SetValue(xsiObj.material +".Name", "EFX_FluidFireSmokeShader", null);
			SetExpr(shader+".CurrentFrame", "Fc", null);
			SetValue(shader+".FolderPath",  ActiveProject2.Path+"/efx_cache/" + ActiveProject.ActiveScene, null);
         }
 }


var simTree = CreateSimulatedICETree(meshCubeCont, siNode, null);
SetValue(simTree+".Name", "EFX_Simulate", null);

var initTree = ApplyOp("ICETree", meshCubeCont, siNode, null, null, 0);
SetValue(initTree+".Name", "EFX_Initialize", null);
MoveOperatorAfter(meshCubeCont + ".polymsh", initTree , meshCubeCont + ".polymsh.geom");

var postTree = ApplyOp("ICETree", meshCubeCont, siNode, null, null, 0);
SetValue(postTree+".Name", "EFX_DataIO", null);
MoveOperatorAfter(meshCubeCont + ".polymsh", postTree , meshCubeCont + ".polymsh.simulationmarker");

//  =========================== setup initialization  =========================== 
comp_initfluid = AddICECompoundNode("EFX Set System Parameters",initTree);
ConnectICENodes(initTree + ".port1", comp_initfluid+".Perform");

// =========================== setup simulation  =========================== 
// add execute node
var execNodesHub = AddICENode("$XSI_DSPRESETS\\ICENodes\\ExecuteNode.Preset", simTree);
ConnectICENodes(simTree+".port1", execNodesHub+".execute");


// add more execution ports
for ( i = 0 ; i<10; ++i )
	AddPortToICENode(execNodesHub + ".port1", siNodePortDataInsertionLocationAfter);

var execHubComment = CreateICENodeComment(execNodesHub);
SetValue(execHubComment+".Text", "disconnect after simulation and caching", null);

// add base simulation parameters
comp_setBaseFluidParams = AddICECompoundNode("EFX Set Fluid Simulation Parameters", simTree);
ConnectICENodes(execNodesHub+".port2", comp_setBaseFluidParams+ ".Perform");

// add sdf emitter
comp_sdfEmit = AddICECompoundNode("EFX Emit From SDF", simTree);
ConnectICENodes(execNodesHub + ".port3", comp_sdfEmit+".Perform");

// add sdf from prim
comp_prim2sdf = AddICECompoundNode("EFX SDF From Primitive", simTree);
ConnectICENodes(comp_sdfEmit + ".Emitter_SDF", comp_prim2sdf+".SDF");

// add emitter manipulator
var emitterManip= GetPrim("Null", null, null, null); 
SetValue(emitterManip+".Name", "EFX_FireSmokeEmitter", null);
//SetValue("EFX_Emitter.null.shadow_icon", 10, null);
SetValue(emitterManip+".kine.global.sclx", 5, null);
SetValue(emitterManip+".kine.global.scly", 5, null);
SetValue(emitterManip+".kine.global.sclz", 5, null);

// connect it
var nd_getEmitNullData = AddICENode("GetDataNode",simTree);
SetValue ( nd_getEmitNullData + ".reference", emitterManip.name, null);
ConnectICENodes(comp_prim2sdf+".Manipulator_Ref", nd_getEmitNullData+".outname");



// add sim node
comp_simMainNode= AddICECompoundNode("EFX Simulate Fluid", simTree);
ConnectICENodes(execNodesHub+".port11", comp_simMainNode+ ".Perform");


// add max container manipulator
var maxCont = GetPrim("Null", null, null, null);
SetValue(maxCont+".Name", "EFX_FireSmokeBoundingContainer", null);
SetValue(maxCont+".null.primary_icon", 4, null);
SetValue(maxCont+".kine.global.sclx", 50, null);
SetValue(maxCont+".kine.global.scly", 50, null);
SetValue(maxCont+".kine.global.sclz", 50, null);
SetValue(maxCont+".kine.global.posy", 15, null);

// connect it
var nd_getMaxcontNullData = AddICENode("GetDataNode",simTree);
SetValue ( nd_getMaxcontNullData + ".reference", maxCont.name, null);
ConnectICENodes(comp_setBaseFluidParams+".Bounding_Container", nd_getMaxcontNullData+".outname");

// add fcurve on smoke-fuel gen
var comp_fcr_smokefuel = AddICECompoundNode("EFX FCurve Scalar",simTree);
ConnectICENodes(comp_setBaseFluidParams+".Smoke_From_Fuel",comp_fcr_smokefuel+ ".Result");
 CreateICENodeComment(comp_fcr_smokefuel);
SetValue(comp_fcr_smokefuel+".ICETreeComment.Text", "remaining fuel in voxel as input arg", null);


// =========================== setup IO and display  =========================== 
for ( i = 0 ; i<10; ++i )
	AddPortToICENode(postTree + ".port1", siNodePortDataInsertionLocationAfter);

var comp_udpContFields = AddICECompoundNode("EFX Update Active Container Cube", postTree);
ConnectICENodes(postTree+".port1", comp_udpContFields+".Perform");

var comp_gigaShader = AddICECompoundNode("EFX Fluid Giga Shader", postTree);
ConnectICENodes(postTree+".port2", comp_gigaShader+".Perform");

var comp_volRender= AddICECompoundNode("EFX Volume Render", postTree);
ConnectICENodes(postTree+".port3", comp_volRender+".Perform");

var comp_dispSS = AddICECompoundNode("EFX Display Primary Scalar Slices", postTree);
ConnectICENodes(postTree+".port9", comp_dispSS+".Perform");

var comp_dispNativeVx = AddICECompoundNode("EFX Native Display Voxels", postTree);
ConnectICENodes(postTree+".port10", comp_dispNativeVx+".Perform");


	
// attach arnold properties and set proper raymarch stepsize when arni installed
if (Application.Plugins ( "Arnold Render" ) )
{
		SITOA_AddParametersProperties(meshCubeCont, null);
		SetValue( meshCubeCont+".Arnold_Parameters.step_size", 0.5, null);
}


// open preview window
efx_openprevwin ();

//========================= finalize ===============================
// select
SelectObj(meshCubeCont, null, null);


    return true;
};




function efx_createStaticVolume ( in_ctxt )
{
var meshCubeCont = CreatePrim("Cube", "MeshSurface", null, null);
SetValue(meshCubeCont+".Name", "EFX_ActiveContainer", null);
SetValue(meshCubeCont+".visibility.selectability", false, null);

var initTree = ApplyOp("ICETree", meshCubeCont, siNode, null, null, 0);
SetValue(initTree+".Name", "EFX_StaticVolume", null);
//  =========================== setup initialization  =========================== 
comp_initfluid = AddICECompoundNode("EFX Set System Parameters",initTree);
ConnectICENodes(initTree + ".port1", comp_initfluid+".Perform");
// add more execution ports
for ( i = 0 ; i<11; ++i )
	AddPortToICENode(initTree + ".port1", siNodePortDataInsertionLocationAfter);
	
	
	
	
	// add max container manipulator
var maxCont = GetPrim("Null", null, null, null);
SetValue(maxCont+".Name", "EFX_StaticBoundingContainer", null);
SetValue(maxCont+".null.primary_icon", 4, null);
SetValue(maxCont+".kine.global.sclx", 50, null);
SetValue(maxCont+".kine.global.scly", 50, null);
SetValue(maxCont+".kine.global.sclz", 50, null);
//SetValue(maxCont+".kine.global.posy", 15, null);

// add resizing node and null aabb
var comp_resize = AddICECompoundNode("EFX Resize Fields", initTree);
ConnectICENodes(initTree+".port2", comp_resize+".Perform");
var com_getNullAABB = AddICECompoundNode("Get Null Bounding Box", initTree); 
ConnectICENodes(initTree+".EFX_Resize_Fields.Minpos", com_getNullAABB+".minp");
ConnectICENodes(initTree+".EFX_Resize_Fields.Maxpos", com_getNullAABB+"..maxp");

// connect it
var nd_getMaxcontNullData = AddICENode("GetDataNode",initTree);
SetValue ( nd_getMaxcontNullData + ".reference", maxCont.name, null);
ConnectICENodes(initTree+".Get_Null_Bounding_Box.In_Name", nd_getMaxcontNullData+".outname");
	
	
	// connect smoke
var comp_smokeAcc=	AddICECompoundNode("EFX Get Smoke",initTree);
ConnectICENodes(comp_resize+".Field", comp_smokeAcc+".Smoke");


//setup platonic sphere stamp
var comp_platSphere =AddICECompoundNode("EFX Platonic Sphere Single", initTree);
ConnectICENodes(initTree+".port3",comp_platSphere+ ".Perform");
ConnectICENodes(comp_platSphere+".Field", comp_smokeAcc+".Smoke");

// setup volume render
var comp_dispSS = AddICECompoundNode("EFX Display Scalar Slice", initTree);
ConnectICENodes(initTree+".port9", comp_dispSS+".Perform");

var comp_smokeShader = AddICECompoundNode("EFX Fluid Smoke Shader", "EFX_ActiveContainer.polymsh.EFX_StaticVolume");
ConnectICENodes(initTree+".port10", comp_smokeShader+".Perform");

var comp_volRender = AddICECompoundNode("EFX Volume Render", "EFX_ActiveContainer.polymsh.EFX_StaticVolume");
ConnectICENodes(initTree+".port11", comp_volRender+".Perform");


var comp_contResizer =AddICECompoundNode("EFX Fit Container Cube To Field", initTree);
ConnectICENodes(initTree+".port12", comp_contResizer+".Perform");
ConnectICENodes(comp_contResizer+".Field", comp_smokeAcc+".Smoke");


	// attach arnold properties and set proper raymarch stepsize
if (  GetValue ("Passes.RenderOptions.Renderer" )  == "Arnold Render" )
	{
		SITOA_AddParametersProperties(meshCubeCont, null);
		SetValue( meshCubeCont+".Arnold_Parameters.step_size", 0.5, null);
	}


	// open preview window
	efx_openprevwin ();
    return true;
}

function efx_openprevwin ( in_ctxt )
{
EFX_openwin ();
};








//================================================================
//
// @@ lic tools 
//
//================================================================


function gui_licfl_Main()
{
	var oCustomProperty = ActiveSceneRoot.AddProperty( 
	                          "CustomProperty", false,
	                          "Floating license server access" ) ;
		var oLayout = oCustomProperty.PPGLayout		;			  
							  
							 						  

	oCustomProperty.AddParameter3( "server_address", siString ) ;
	oCustomProperty.AddParameter3( "server_port", siUInt2 ) ;



	oLayout .AddGroup("Server IPAddress");
			oLayout .AddGroup();
				oLayout.AddStaticText ( " Either: \n IPv4 address (e.g. - 255.255.255.255) \n IPv6 address (e.g. - 2001:0db8:11a3:09d7:1f34:8a2e:07a0:765d) \n localhost (default option) if the server is running on this workstation" , 400, 60 );
			oLayout.EndGroup();
		oLayout.AddString( "server_address", "IPAddress", false, 120 );
	
	oLayout.EndGroup();
	
	oLayout .AddGroup("Server network Port");

		//oLayout .AddGroup();
			//oLayout.AddStaticText ( "Default is 21875, can be any free from range: 1024-49151" , 400, 20 );
			oLayout.AddStaticText ( "Default server port: 21875. Acceptable user ports range: 1024-49151" , 400, 20 );
		//oLayout.EndGroup();	
	
		var ui_port  =oLayout.AddString( "server_port", "Port", false, 120 );
		ui_port.SetAttribute(siUIValueOnly ,true);
		
	oLayout.EndGroup();
	
	oLayout.AddButton( "Default" , "Default settings") ;		
//	oLayout.AddButton( "Install" , "Install") ;
	
	
	
	oLayout.Language = "Jscript" ;
	oLayout.Logic =  OnInit.toString() +
		server_address_OnChanged.toString()+server_port_OnChanged.toString() +//input changes

		Default_OnClicked.toString()  +Install_OnClicked.toString();//buttons
		
		
	if ( !InspectObj(oCustomProperty, "", "EFX Licensing", siModal, false) )
		EFX_InstallLicense (2, oCustomProperty.server_address.Value,   oCustomProperty.server_port.Value );
	
	
	DeleteObj(oCustomProperty);

	
//
//callbacks
//
function OnInit()
{
	//logmessage ("[EFXTools]: ppg is fired!" );
	PPG.server_address.Value = "localhost";
	PPG.server_port = 21875;		
}

function server_address_OnChanged()
{
		//logmessage ("[EFXTools]: server_address_ONCHANGE is fired!" );
		//logmessage  (PPG.server_address.Value);
}
function server_port_OnChanged()
{
		//logmessage ("[EFXTools]: server_port_ONCHANGE is fired!" );
		//logmessage  ( PPG.server_port.Value);
}
function Install_OnClicked()
{
		//logmessage ("[EFXTools]: Install_clicked is fired!" );
		//logmessage  ( PPG.server_port.Value);
		//logmessage  ( PPG.server_address.Value);
		EFX_InstallLicense (2, PPG.server_address.Value,  PPG.server_port.Value );
}
function Default_OnClicked()
{
		//logmessage ("[EFXTools]: Default_clicked is fired!" );
		//logmessage  ( PPG.server_port.Value);
		PPG.server_address.Value = "localhost";
		PPG.server_port = 21875;	
}


}//end of giu license floating


//======================================================================

function gui_licnl_Main()
{
	var oCustomProperty = ActiveSceneRoot.AddProperty( 
	                          "CustomProperty", false,
	                          "Node-locked license key installation" ) ;
		var oLayout = oCustomProperty.PPGLayout		;			  
							  
							 						  

	oCustomProperty.AddParameter3( "key", siString ) ;


	oLayout .AddGroup("License Key");
			
		oLayout.AddString( "key", "Digits only:", false, 10 );
	
	oLayout.EndGroup();	
//	oLayout.AddButton( "Install" , "Install") ;
	

	oLayout.Language = "Jscript" ;
	oLayout.Logic =  OnInit.toString() +
		key_OnChanged.toString() +//input changes
		Install_OnClicked.toString();//buttons
		
	if ( !InspectObj(oCustomProperty, "", "EFX Licensing", siModal, false) )
		EFX_InstallLicense (1, oCustomProperty.key.Value,  0 );
	
	
	DeleteObj(oCustomProperty);

	
//
//callbacks
//
function OnInit()
{
	//logmessage ("[EFXTools]: ppg is fired!" );
	//PPG.server_address.Value = "localhost";
	//PPG.server_port = 21875;		
}

function key_OnChanged()
{
		//logmessage ("[EFXTools]: server_port_ONCHANGE is fired!" );
		//logmessage  ( PPG.server_port.Value);
}
function Install_OnClicked()
{
		//logmessage ("[EFXTools]: Install_clicked is fired!" );
		//logmessage  ( PPG.server_port.Value);
		//logmessage  ( PPG.server_address.Value);
		EFX_InstallLicense (1, PPG.key.Value,  0 );
}



}//end of giu license node-locked







function gui_getinfo_Main()
{
	var oCustomProperty = ActiveSceneRoot.AddProperty( 
	                          "CustomProperty", false,
	                          "Workstation network properties" ) ;
		var oLayout = oCustomProperty.PPGLayout		;			  
							  
							 						  

	oCustomProperty.AddParameter3( "iplist", siString ) ;
	oCustomProperty.AddParameter3( "maclist", siString ) ;
	oCustomProperty.AddParameter3( "keyfield", siString ) ;
	
	oLayout .AddGroup("Network hardware");
	oLayout .AddGroup();
			var macwidget =oLayout .AddItem( "maclist","MAC Address:", siControlTextEditor );
			macwidget.SetAttribute(siUIHeight, 70);		
			macwidget.SetAttribute(siUIBackgroundColor, 0x979899);
			//ipwidget.SetAttribute(siUIForegroundColor, 0xCC3366)
			oCustomProperty.maclist.value = EFX_GetThisnwInfo  (1);		
		oLayout.EndGroup();
		oLayout .AddGroup();
			var ipwidget =oLayout .AddItem( "iplist","IP Address:", siControlTextEditor );
			ipwidget.SetAttribute(siUIHeight, 70);		
			ipwidget.SetAttribute(siUIBackgroundColor, 0x979899);
	//		//ipwidget.SetAttribute(siUIForegroundColor, 0xCC3366)
			oCustomProperty.iplist.value = EFX_GetThisnwInfo  (0);		
		oLayout.EndGroup();
		
	oLayout.AddButton( "Refresh" , "Refresh") ;	
	oLayout.EndGroup();
	

	
	oLayout .AddGroup( "Product license");

			var keywidget =oLayout .AddItem( "keyfield","State", siControlTextEditor );
			keywidget.SetAttribute(siUIHeight, 85);		
			keywidget.SetAttribute(siUIBackgroundColor, 0x979899);
			oCustomProperty.keyfield.value = EFX_GetThisnwInfo  (2);		
		//oLayout.AddStaticText (  EFX_GetThisnwInfo  (2), 400, 50 );
		
	oLayout.EndGroup();
	

	oLayout.Language = "Jscript" ;
	oLayout.Logic =  Refresh_OnClicked.toString();
		
		
	InspectObj(oCustomProperty, "", "EFX Licensing", siModal, false);
	DeleteObj(oCustomProperty);


	function Refresh_OnClicked()
	{
		PPG.iplist.value = EFX_GetThisnwInfo  (0);
		PPG.maclist.value = EFX_GetThisnwInfo  (1);	
	}

}//end of giu getsatus

function efx_EULA ()
{
             var oCustomProperty = ActiveSceneRoot.AddProperty( 
	                          "CustomProperty", false,
	                          "EULA" ) ;
		var oLayout = oCustomProperty.PPGLayout		;				  
							  
							 						  
		oCustomProperty.AddParameter3( "CONTENT", siString ) ;
		var textwidget =oLayout .AddItem( "CONTENT","", siControlTextEditor );
		textwidget.SetAttribute(siUIHorizontalScroll, false);
		textwidget.SetAttribute(siUISelectionColor,0x0088FF );
		textwidget.SetAttribute(siUIBackgroundColor ,0x333333 );
		textwidget.SetAttribute(siUIForegroundColor ,0xFFFFFF );
		textwidget.SetAttribute(siUIHeight, 370)
		textwidget.SetAttribute(siUILineWrap, true);
		oCustomProperty.CONTENT.value ="IMPORTANT, PLEASE READ CAREFULLY.\n"
+"THIS IS A LICENSE AGREEMENT\n"
+"\n"
+"End User License Agreement\n"
+"\n"
+"This End User License Agreement ('EULA') is a legal agreement between you (either an individual or a single entity) and Blackcore tech. company with regard to the copyrighted Software (herein referred to as 'ExplosiaFX software' or 'ExplosiaFX' provided with this EULA. The ExplosiaFX software includes computer software, the associated media, any printed materials, and any 'online' or electronic documentation. Use of any software and related documentation provided to you by Blackcore tech. company in whatever form or media, will constitute your acceptance of these terms, unless separate terms are provided by the software supplier, in which case certain additional or different terms may apply. If you do not agree with the terms of this EULA, do not download, install, copy or use the Software. By installing, copying or otherwise using the ExplosiaFX software, you agree to be bound by the terms of this EULA. If you do not agree to the terms of this EULA, Blackcore tech. company is unwilling to license the ExplosiaFX software to you." 
+"1. Eligible Licensees. This Software is available for license solely to ExplosiaFX owners, with no right of duplication or further distribution, licensing, or sub-licensing. IF YOU DO NOT OWN THE ExplosiaFX, THEN DO NOT DOWNLOAD, INSTALL, COPY OR USE THE ExplosiaFX. "
+"2. License Grant. Blackcore tech. company grants to you a limited, non-transferable and non-exclusive license either of 4 types:"
	+"1)COMMERCIAL license: ( a ) to use the ExplosiaFX software for commercial work; ( b ) to install the ExplosiaFX software on a network server and use that number of copies of the ExplosiaFX  software as have been licensed and paid for at any one time; ( c ) to copy the ExplosiaFX software solely for the purpose of installing it on the your computers and for backup storage."
	+"2)NONCOMMERCIAL (or TRIAL) license: ( a ) to use the ExplosiaFX software for any work except commercial; ( b ) to install the ExplosiaFX software on a network server and use that number of copies of the ExplosiaFX  software; ( c ) to copy the ExplosiaFX software solely for the purpose of installing it on the your computers and for backup storage."
	+"3)BETA license: to use the early/experimental ExplosiaFX software modifications for commercial work without official support and need to being paid; "
	+"4) EDUCATIONAL license: ( a ) to use the ExplosiaFX software either for  self-education or/and for teaching (including paid teaching)  the third party and not for any other commercial work; ( b ) to install the ExplosiaFX software on a network server and use that number of copies of the ExplosiaFX  software as have been licensed and paid for at any one time."

+"Modifying, translating, renting, copying, transferring or assigning all or part of the Software, or any rights granted hereunder, to any other persons and removing any proprietary notices, labels or marks from the Software is strictly prohibited. Furthermore, you hereby agree not to create derivative works based on the Software. You may not transfer this Software. "
+"3. Copyright. The Software is licensed, not sold. You acknowledge that no title to the intellectual property in the Software is transferred to you. You further acknowledge that title and full ownership rights to the Software will remain the exclusive property of Blackcore tech. company and/or its suppliers, and you will not acquire any rights to the Software, except as expressly set forth above. All copies of the Software will contain the same proprietary notices as contained in or on the Software. All title and copyrights in and to the ExplosiaFX software (including but not limited to any images, photographs, animations, video, audio, music, text and applets, incorporated into the ExplosiaFX software), the accompanying printed materials, and any copies of the ExplosiaFX software, are owned by Blackcore tech. company or its suppliers. The ExplosiaFX software is protected by copyright laws and international treaty provisions. You may not copy the printed materials accompanying the ExplosiaFX software." 
+"4. Reverse Engineering. You agree that you will not attempt, and if you are a corporation, you will use your best efforts to prevent your employees and contractors from attempting to reverse compile, modify, translate or disassemble the Software in whole or in part. Any failure to comply with the above or any other terms and conditions contained herein will result in the automatic termination of this license and the reversion of the rights granted hereunder to Blackcore tech. company." 
+"5. Disclaimer of Warranty. The Software is provided 'AS IS' without warranty of any kind. Blackcore tech. company and its suppliers disclaim and make no express or implied warranties and specifically disclaim the warranties of merchantability, fitness for a particular purpose and non-infringement of third-party rights. The entire risk as to the quality and performance of the Software is with you. Neither Blackcore tech. company nor its suppliers warrant that the functions contained in the Software will meet your requirements or that the operation of the Software will be uninterrupted or error-free."
+"6. Limitation of Liability. Blackcore tech. company's entire liability and your exclusive remedy under this EULA shall not exceed the price paid for the Software, if any. In no event shall Blackcore tech. company or its suppliers be liable to you for any consequential, special, incidental or indirect damages of any kind arising out of the use or inability to use the software, even if Blackcore tech. company or its supplier has been advised of the possibility of such damages, or any claim by a third party. "
+"7. Rental. You may not loan, rent, or lease the ExplosiaFX."
+"8. Upgrades. If the ExplosiaFX is an upgrade from an earlier release or previously released version, you now may use that upgraded product only in accordance with this EULA. If the ExplosiaFX software is an upgrade of a software program which you licensed as a single product, the ExplosiaFX software may be used only as part of that single product package and may not be separated for use on more than one computer. "
+"9. OEM Product Support. Product support for the ExplosiaFX software IS provided by Blackcore tech. company except of BETA licensed modifications. For product support, please write to Blackcore tech. company support email. Should you have any questions concerning this, please refer to the address provided in the documentation. "
+"10. No Liability for Consequential Damages. In no event shall Blackcore tech. company or its suppliers be liable for any damages whatsoever (including, without limitation, incidental, direct, indirect special and consequential damages, damages for loss of business profits, business interruption, loss of business information, or other pecuniary loss) arising out of the use or inability to use this Blackcore tech. company product, even if Blackcore tech. company has been advised of the possibility of such damages. Because some states/countries do not allow the exclusion or limitation of liability for consequential or incidental damages, the above limitation may not apply to you. "
+"11. Indemnification By You. If you distribute the Software in violation of this Agreement, you agree to indemnify, hold harmless and defend Blackcore tech. company and its suppliers from and against any claims or lawsuits, including attorney's fees that arise or result from the use or distribution of the Software in violation of this Agreement."
+"\n\nBlackcore tech. company , Ukraine, Kharkov, Garshina 9, support@blackcore.technology"
+"\n\nBlackcore tech. 2014-2015 All rights reserved.";




		
	InspectObj(oCustomProperty, "", "Blackcore SoftimageExplosiaFX Legal Notice", siModal, false);
	DeleteObj(oCustomProperty);




}


